Attribute VB_Name = "modComDlgRep"
'Dieser Source stammt von http://www.ws-software.co.cc
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'This source code originates from http://www.ws-software.co.cc
'it is as-is without any warranty and can be used freely
'In no event shall the author be held liable for any damages arising from the use of this code


Option Explicit

'declaration of APIs
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryA" (ByVal pszPath As String) As Long


'declaration of type
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'to see all the APIs and declarations you could use go to:
'C:\Program Files\Microsoft Visual Studio\Common\Tools\Winapi
'there is a Viewer called "APILOAD.EXE"
'and text files with all the declarations you need ("WIN32API.TXT")



'Example:
'txtFile = "Open:" & vbCrLf & _
           ComdlgReplacement("Open", App.Path, _
           "All Files (*.*) | Text Files (*.txt) | VB Project Files (*.vbp)", Me)

'SaveOpen = "Save" or "Open"
'InitDir = "C:\Initial Directory\"
'sFilter  = "Filename (*.*)", e.g. "All Files (*.*)" or "Text Files (*.txt)"
'sFilter  = "All Files (*.*)| Text Files (*.txt)| Batch Files (*.bat)" -> multiple separated by "|"
'ComdlgReplacement = ""      if cancel pressed
'ComdlgReplacement = "File"  if file is selected
Public Function ComdlgReplacement(ByVal SaveOpen As String, _
                           ByVal sInitDir As String, _
                           ByVal sFilter As String, _
                           ByVal CallingForm As Form) As String
   
   Dim OpenSaveFile As OPENFILENAME
   Dim lReturn As Long
   Dim sReturnFile As String
   Dim sFilt As String
   Dim h As String
   Dim F() As String, FF() As String
   Dim i As Integer
   
   If IsFolder(sInitDir) Then
     OpenSaveFile.lpstrInitialDir = sInitDir
   Else
     OpenSaveFile.lpstrInitialDir = "C:\" 'or something like: App.Path
   End If
   
   'Filter:
   sFilter = Replace(sFilter, "| ", "|") '"All Files (*.*) | Text Files (*.txt)" -> "All Files (*.*) |Text Files (*.txt)" and now easy to split:
   sFilter = Replace(sFilter, " |", "|") '"All Files (*.*) |Text Files (*.txt)" -> "All Files (*.*)|Text Files (*.txt)" and now easy to split:
   F = Split(sFilter, "|")
   'e.g.
   'F(0) = "All Files (*.*)"
   'F(1) = "Text Files (*.txt)"
   'F(2) = "Batch Files (*.bat)"
   
   For i = 0 To UBound(F)
     h = F(i)                  'F(i)  = "All Files (*.*)"
     h = Replace(h, " (", "(") 'h     = "All Files (*.*)" -> "All Files(*.*)"
     h = Replace(h, ")", "")   'h     = "All Files (*.*)2 -> "All Files(*.*" -> now easy to split
     FF = Split(h, "(")        'FF(0) = "All Files": FF(1) ="*.*"
     If UBound(FF) = 1 Then
       sFilt = sFilt & F(i) & Chr(0) & FF(1) & Chr(0)
     End If
   Next
   OpenSaveFile.lpstrFilter = sFilt
   OpenSaveFile.nFilterIndex = 1
   
   OpenSaveFile.lStructSize = Len(OpenSaveFile)
   OpenSaveFile.hwndOwner = CallingForm.hWnd
   OpenSaveFile.hInstance = App.hInstance
   OpenSaveFile.lpstrFile = String(257, 0)
   OpenSaveFile.nMaxFile = Len(OpenSaveFile.lpstrFile) - 1
   OpenSaveFile.lpstrFileTitle = OpenSaveFile.lpstrFile
   OpenSaveFile.nMaxFileTitle = OpenSaveFile.nMaxFile
   OpenSaveFile.flags = 0
   
    
   If LCase(SaveOpen) = "save" Then
      OpenSaveFile.lpstrTitle = "Save"
      lReturn = GetSaveFileName(OpenSaveFile)
   ElseIf LCase(SaveOpen) = "open" Then
      OpenSaveFile.lpstrTitle = "Open"
      lReturn = GetOpenFileName(OpenSaveFile)
   End If
   
   If lReturn = 0 Then
     sReturnFile = ""
   Else
     sReturnFile = Trim(OpenSaveFile.lpstrFile)
   End If
   
   ComdlgReplacement = sReturnFile
End Function



Public Function IsFolder(ByVal Path As String) As Boolean
    IsFolder = CBool(PathIsDirectory(Path))
End Function




